import { Metadata, Http } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class AFGeneralModalController {
  private AFGeneralModal!: Modal;

  public async createAFGeneralModal() {
    this.AFGeneralModal = await ModalService.createFromJson('/modals/aFGeneralTAGridModal', true);
  }

  public destroyAFGeneralModal() {
    this.AFGeneralModal?.destroy();
  }

  public async openAFGeneralModal({ component }, seriesData) {
    const props = component.options.props;
    const gridRoute = props.gridRoute;
    await this.AFGeneralModal.show();
    const gridGroup = Metadata.getInstance<TekGrid>('aFGeneralTAGridGroup');
    gridGroup.title = `${component.options.fullTitle.text} > ${seriesData.name}`;
    
    let queryString = 'requestType=FilterData';
    queryString += `&OPERADOR=${seriesData.CDOPERADOR}`;
    queryString += `&IDCONFRECEBIMENTO=${seriesData.IDCONFRECEBIMENTO}`;
    queryString += `&NMESTADO=${seriesData.ESTADO}`;
    queryString += `&NMREGIAOGEO=${seriesData.REGIAO}`;
    
    Http.get(`/${gridRoute}?${queryString}`).then(({ data }) => {
      gridGroup.datasource.updateData(data.dataset.aFGeneralTAGridGroup);
    });
  }

  public closeAFGeneralModal() {
    this.AFGeneralModal.hide();
  }
}
